REBOL [
	Title: "Image Magick Extension Test"
	author: "Jocko"
	date: 13-Nov-2010
	comment: {
	for Windows only .
	Tested with Windows XP, ImageMagick-6.6.5-Q16, Ghostscript 8.61
	installation :
	- install the ImageMagick runtime or the full ImageMagick package
	- in case of using pdf format, install Ghostscript http://pages.cs.wisc.edu/~ghost/

	7-Nov-2010	first tests ...	return values and strings not processed
	10-Nov-2010 interfacing with Rebol Images
	}
]

secure [extension allow]
import %MagickExt.dll

print "--- test Magick Extension for R3 --- "
help Magick
print " "

{There are 3 main commands :
Magick, Magick-load, Magick-save, which can be used alone or combined to interface the two worlds, without passing by disk reads/writes}

; --- Magick command
{Magick gives access to the command line interpreter of ImageMagick. It is full of options and possibilities. 
Inputs and outputs are made from and to files, with a very large number of image formats, 
including pdf if Ghostscript is installed }

Magick "convert label.gif label.jpg"
Magick "convert -resize 400x400 label.gif label2.jpg"
Magick "convert logo: logo.jpg"
Magick {convert -resize "200x200>" logo: logo.gif}

; more complex examples from http://www.imagemagick.org/script/command-line-processing.php
Magick {convert label.gif +matte ( +clone -shade 110x90 -normalize -negate +clone -compose Plus -composite ) ( -clone 0 -shade 110x50 -normalize -channel BG -fx 0 +channel -matte ) -delete 0 +swap -compose Multiply -composite button.gif}

Magick {montage -background #336699 -geometry +4+4 label2.jpg logo.jpg montage.jpg}

; this line may need to install Ghostscript: http://pages.cs.wisc.edu/~ghost/
; Magick "convert montage.jpg  montage.pdf"

; --- Magick-load command
{Magick-load allows to load an image in the Rebol environment, with the full set of ImageMagick formats}
im: Magick-load "label.gif"
print im/size

; --- Magick-save command
{Magick-save allows to save a Rebol image, with the full set of ImageMagick formats}
im: load %logo.gif
;Magick-save im "res3.pdf"  
Magick-save im "res3.jpg"
print "image saved"

; --- Command combinations, full interfacing
{allows exchange between Rebol and ImageMagick, without passing by read/write on the disk.
We exchange data thanks to "memory program register" (mpr), a pseudo-file format, used like a normal file, allowing in-memory saves.
Specific functions can then be defined}

edge: func[ im [image!]][
	Magick-save im "mpr:im1"
	Magick "convert mpr:im1 -edge 1 mpr:im1r"
	im: Magick-load "mpr:im1r"
	im
	]

im1: load %logo.jpg
im: edge im1

; only for check
Magick-save im "res4.jpg"
 

ask "done"